/*
This file is automatically generated by (db version 1):
awk -f tools/gen_sql.awk tools/vdsmdb-v1.sql > src/datamodel.sql.h
*/

#ifndef _DATAMODEL_SQL_H_
#define _DATAMODEL_SQL_H_


#define CREATE_DB_V14 " \
BEGIN TRANSACTION; \
CREATE TABLE db_config ( \
        key VARCHAR(40) PRIMARY KEY NOT NULL, \
        value VARCHAR(255) NOT NULL \
); \
CREATE TABLE deviceBinaryInputs ( \
        deviceId INTEGER, \
        inputIndex INTEGER, \
        targetGroup INTEGER, \
        type INTEGER, \
        buttonId INTEGER, \
        name TEXT, \
        PRIMARY KEY (deviceId, inputIndex), \
        FOREIGN KEY (deviceId) REFERENCES devices(deviceId) ON DELETE CASCADE \
); \
CREATE TABLE deviceButtons ( \
        deviceId INTEGER PRIMARY KEY, \
        buttonIdAndGroup INTEGER, \
        buttonUserGroup INTEGER, \
        buttonSetLocalPriority INTEGER, \
        buttonNoComingHomeCall INTEGER, \
        buttonApartment INTEGER, \
        buttonOutputChannel INTEGER, \
        buttonGlobalGroup INTEGER, \
        FOREIGN KEY (deviceId) REFERENCES devices(deviceId) ON DELETE CASCADE \
); \
CREATE TABLE deviceDefaultChannel ( \
        deviceId INTEGER PRIMARY KEY, \
        FOREIGN KEY (deviceId) REFERENCES devices(deviceId) ON DELETE CASCADE \
); \
CREATE TABLE deviceOpcs ( \
        deviceId INTEGER, \
        opcIndex INTEGER, \
        channelId INTEGER, \
        PRIMARY KEY (deviceId, opcIndex), \
        FOREIGN KEY (deviceId) REFERENCES devices(deviceId) ON DELETE CASCADE \
); \
CREATE TABLE deviceSensors ( \
        deviceId INTEGER, \
        sensorIndex INTEGER, \
        type INTEGER, \
        pollInterval INTEGER, \
        broadcast INTEGER, \
        pushConvert INTEGER, \
        name TEXT, \
        PRIMARY KEY (deviceId, sensorIndex), \
        FOREIGN KEY (deviceId) REFERENCES devices(deviceId) ON DELETE CASCADE \
); \
CREATE TABLE devices ( \
        deviceId INTEGER PRIMARY KEY, \
        dsuid TEXT(35) NOT NULL, \
        vid INTEGER, \
        fid INTEGER, \
        pid INTEGER, \
        ver INTEGER, \
        locked INTEGER, \
        localZoneId INTEGER NOT NULL, \
        groupMembership INTEGER, \
        ltmode INTEGER, \
        mode INTEGER, \
        name TEXT, \
        active INTEGER, \
        vdcdsuid TEXT(35), \
        UNIQUE(dsuid) \
); \
CREATE TABLE dsm_info ( \
        dsuid TEXT(35) NOT NULL, \
        apartmentId INTEGER, \
        flags INTEGER, \
        autoPingInterval INTEGER, \
        oneTimePingInterval INTEGER, \
        name TEXT(20), \
        warnTemperature INTEGER, \
        errorTemperature INTEGER, \
        upstreamFrequency INTEGER, \
        UNIQUE(dsuid) \
); \
CREATE TABLE groups ( \
        g_id INTEGER PRIMARY KEY, \
        stateMachineGroupId INTEGER, \
        stopTimeout INTEGER, \
        remoteStopTimeout INTEGER, \
        name TEXT(20) , \
        stopTimeoutActive INTEGER \
); \
CREATE TABLE heating ( \
        zoneId INTEGER, \
        Kp INTEGER, \
        Kd INTEGER, \
        Ti INTEGER, \
        imin INTEGER, \
        imax INTEGER, \
        ymin INTEGER, \
        ymax INTEGER, \
        Ts INTEGER, \
        antiWindUp INTEGER, \
        sourceZoneId INTEGER, \
        offset INTEGER, \
        emergencyValue INTEGER, \
        manualValue INTEGER, \
        keepFloorWarm INTEGER, \
        controllerMode INTEGER, \
        UNIQUE(zoneId) \
); \
CREATE TABLE heatingOperationMode ( \
        zoneId INTEGER, \
        operationMode BLOB, \
        UNIQUE(zoneId) \
); \
CREATE TABLE scenes ( \
        s_id INTEGER PRIMARY KEY, \
        id INTEGER, \
        name TEXT(20) \
); \
CREATE TABLE zoneSensors ( \
        localZoneId INTEGER, \
        type INTEGER, \
        dsuid TEXT(35) NOT NULL \
); \
CREATE TABLE zones ( \
        localZoneId INTEGER PRIMARY KEY, \
        zoneId INTEGER, \
        zoneTagId INTEGER, \
        name TEXT(20) \
); \
INSERT INTO db_config VALUES('db_version', '14'); \
COMMIT; \
"

#define CONVERT_TO_DB_V15 " \
BEGIN TRANSACTION; \
ALTER TABLE heating ADD vdcdsuid TEXT(35); \
UPDATE db_config SET value=15 WHERE key ='db_version'; \
COMMIT; \
"

#define CONVERT_TO_DB_V16 " \
PRAGMA foreign_keys = no; \
PRAGMA recursive_triggers = no; \
PRAGMA ignore_check_constraints = yes; \
BEGIN TRANSACTION; \
ALTER TABLE devices RENAME TO devices_old; \
CREATE TABLE devices ( \
        deviceId INTEGER PRIMARY KEY, \
        dsuid TEXT(35) NOT NULL, \
        vid INTEGER, \
        fid INTEGER, \
        ver INTEGER, \
        locked INTEGER, \
        localZoneId INTEGER NOT NULL, \
        groupMembership INTEGER, \
        ltmode INTEGER, \
        mode INTEGER, \
        name TEXT, \
        active INTEGER, \
        vdcdsuid TEXT(35), \
        UNIQUE(dsuid) \
); \
INSERT INTO devices \
        SELECT deviceId, \
        dsuid, \
        vid, \
        fid, \
        ver, \
        locked, \
        localZoneId, \
        groupMembership, \
        ltmode, \
        mode, \
        name, \
        active, \
        vdcdsuid \
        FROM devices_old; \
DROP TABLE devices_old; \
UPDATE db_config SET value=16 WHERE key ='db_version'; \
COMMIT; \
PRAGMA foreign_keys = yes; \
PRAGMA recursive_triggers = yes; \
PRAGMA ignore_check_constraints = no; \
"

#define CONVERT_TO_DB_V17 " \
BEGIN TRANSACTION; \
CREATE TABLE cluster ( \
     clusterId INTEGER PRIMARY KEY, \
     stateMachineGroupId INTEGER, \
     stopTimeout INTEGER, \
     remoteStopTimeout INTEGER, \
     name TEXT(20), \
     location INTEGER DEFAULT 0, \
     floor INTEGER DEFAULT 0, \
     protectionClass INTEGER DEFAULT 0, \
     configurationLock INTEGER DEFAULT 0 \
    ); \
CREATE TABLE clusterSceneLock ( \
    clusterId INTEGER, \
    sceneLockIndex INTEGER, \
    sceneLock INTEGER \
    ); \
UPDATE db_config SET value=17 WHERE key ='db_version'; \
COMMIT; \
"

#define CONVERT_TO_DB_V18 " \
BEGIN TRANSACTION; \
CREATE TABLE sceneLockCluster ( \
    clusterId INTEGER PRIMARY KEY, \
    value INTEGER \
    ); \
UPDATE db_config SET value=18 WHERE key ='db_version'; \
DROP TABLE clusterSceneLock; \
COMMIT; \
"

#define CONVERT_TO_DB_V19 " \
BEGIN TRANSACTION; \
ALTER TABLE dsm_info ADD defaultZoneId INTEGER DEFAULT 0; \
UPDATE db_config SET value=19 WHERE key ='db_version'; \
COMMIT; \
"
#define CONVERT_TO_DB_V20 " \
DROP TABLE deviceDefaultChannel; \
UPDATE db_config SET value=20 WHERE key ='db_version'; \
COMMIT; \
"

#endif //_DATAMODEL_SQL_H_
