/*
    Copyright (c) 2016 digitalSTROM AG, Zurich, Switzerland

    This file is part of vdSM.

    vdSM is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 2 of the License.

    vdSM is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with vdSM. If not, see <http://www.gnu.org/licenses/>.
*/
#include "watchdog.h"

#include <ds/asio/test.h>
#include <util.h>
#include <atomic>
#include <boost/thread.hpp>

namespace ds {
namespace asio {

class WatchdogTest : public ::testing::Test {};

TEST_F(WatchdogTest, test) {
    //     vdsm_init_report(7);
    boost::asio::io_service ioService(1);
    auto latency = ds::asio::test::LATENCY / 3;
    Watchdog watchdog(ioService, latency);
    std::atomic<bool> timeout(false);
    watchdog.setTimeoutFunction([&]() {
        // Runs in non-ioService thread
        timeout = true;
        ioService.stop();
    });
    ASSERT_RUN_NO_STOP(ioService);
    ASSERT_FALSE(timeout);
    boost::this_thread::sleep_for(latency * 2);
    ASSERT_TRUE(timeout);
}
}
} // namespace ds::vdsm
